#include "DxLib.h"
#include "board.h"
#include "config.h"
#include "gamedata.h"
#include "cursor.h"

//݂̃J[\̍W8
#define VECTOR_ALL 8
//`bv摜ϐ
static int m_Chip[3];
//{[hԂi[ϐ
static int m_Board[BOARD_WIDTH][BOARD_HEIGHT];
//xNgϐ
static int vector_x[VECTOR_ALL] = { 0, 1, 1, 1, 0, -1, -1, -1 };
static int vector_y[VECTOR_ALL] = { -1, -1, 0, 1, 1, 1, 0, -1 };

//{[h
void Board_Init(){
	int i, j;
	for (i = 0; i < BOARD_WIDTH; i++){
		for (j = 0; j < BOARD_HEIGHT; j++){
			m_Board[i][j] = 0;
		}
	}
	LoadDivGraph("img/chip.png", 3, 3, 1, BOARDCHIP_SIZE, BOARDCHIP_SIZE, m_Chip);

	m_Board[3][3] = 2;
	m_Board[4][3] = 1;
	m_Board[3][4] = 1;
	m_Board[4][4] = 2;
}

int Board_Check(){
	int vec;
	//ǂꂩłЂԂ邩mF
	for (vec = 0; vec < VECTOR_ALL; ++vec){
		if (Board_Checkflip(vec) == 0) { return 0; }
	}
	return 1;
}

int Board_Checkflip(int i){
	int flag = 0,j;

	static Cursor_t tmp_CursorData = Cursor_Get();
	int kx = tmp_CursorData.cursor_x;
	int ky = tmp_CursorData.cursor_y;
	for (j = 0; j < BOARDCHIP_SIZE; j++){

		kx = kx + (j+1) * vector_x[i];
		ky = ky + (j+1) * vector_y[i];

		//Ֆʂ̊OɏoĂI
		if (kx < 0 || ky < 0 || kx > BOARDCHIP_SIZE - 1 || ky > BOARDCHIP_SIZE - 1) return 1;

		//󂫃}XI
		if (m_Board[kx][ky] == NONE) return 1;

		//̃R}tO𗧂Ă
		if (m_Board[kx][ky] == (2 / MainData.turn)){ flag = 1; continue; }

		if (m_Board[kx][ky] == MainData.turn && flag == 1){ return 0; }
	}
	return 1;
}

int Board_Flip(int i){

	return 0;
}

//{[hɃR}u֐
int Board_Putchip(int Board_x, int Board_y){
	if (Board_Check() == 0 && m_Board[Board_x][Board_y] == 0){
			m_Board[Board_x][Board_y] = MainData.turn;
			MainData.turn = 2 / MainData.turn;
			MainData.Gamecount++;
			return 0;
	}
	return 1;
}

//`֐
void Board_Draw(){
	int i, j;
	for (i = 0; i < BOARD_WIDTH; i++){			//
		for (j = 0; j < BOARD_HEIGHT; j++){		//c
			switch (m_Board[i][j]){
			case NONE:
				DrawGraph(BOARDCHIP_SIZE * i, BOARDCHIP_SIZE * j, m_Chip[0], TRUE);
				break;
			case BLACK:
				DrawGraph(BOARDCHIP_SIZE * i, BOARDCHIP_SIZE * j, m_Chip[1], TRUE);
				break;
			case WHITE:
				DrawGraph(BOARDCHIP_SIZE * i, BOARDCHIP_SIZE * j, m_Chip[2], TRUE);
				break;
			}
		}
	}
}
