#include "DxLib.h"
#include "gamedata.h"
#include "cursor.h"
#include "board.h"
#include "keyboard.h"

static Cursor_t tmp_cursor;

static int White = GetColor(255, 255, 255);	//Fϐ

//C֐
void Game_Init(){
	MainData.Gamecount = 0;
	MainData.turn = 1;
	tmp_cursor.cursor_x = 0;
	tmp_cursor.cursor_y = 0;

	DxLib_Init();
	Board_Init();
	Cursor_Init();
}

void Game_Update(){
	Keyboard_Update();
	Cursor_Update();
	if (Keyboard_Get(KEY_INPUT_Z) == 1){
		tmp_cursor = Cursor_Get();
		Board_Putchip(tmp_cursor.cursor_x, tmp_cursor.cursor_y);
	}
}

void Game_Draw(){

	//`֐
	Board_Draw();
	Cursor_Draw();

	if (MainData.turn == 1){
		DrawString(200, 60, "̃^[", White);
	}
	else if (MainData.turn == 2){
		DrawString(200, 60, "̃^[", White);
	}

	DrawFormatString(200, 30, White, "WX:%d WY:%d", tmp_cursor.cursor_x + 1, tmp_cursor.cursor_y + 1);
}