#include "DxLib.h"
#include "board.h"
#include "config.h"
#include "cursor.h" 
#include "keyboard.h"
#include "gamedata.h"

GameData_t MainData;

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int){
	ChangeWindowMode(TRUE);
	SetDrawScreen(DX_SCREEN_BACK);
	SetGraphMode(SCREEN_X, SCREEN_Y, 32);
	Game_Init();

	while (ScreenFlip() == 0 && ProcessMessage() == 0 &&
		ClearDrawScreen() == 0 && Keyboard_Get(KEY_INPUT_ESCAPE) == 0){

		Game_Update();
		Game_Draw();
	}
	DxLib_End(); // DXCuI
	return 0;
}